this.name = "scannerCursor";

"use strict";

//Setting for cursor movement in m/s:
this._cursorSpeed = 10000
//and how close it must get to the target:
this._proximity = 5000;

this._active = false;
this._lastPitch = 0;
this._lastRoll = 0;
this._lastYaw = 0;

this.activated = function()
{
	if (this._active)
	{
		var candidates = system.filteredEntities(this, this._isPossibleTarget, this.Cursor, this._proximity);
		if (candidates[0])
		{
			player.ship.target = candidates[0];
		}
		else player.consoleMessage("No target found");
		
		removeFrameCallback(this.FCB);
		this.Cursor.remove();
		this._active = false;
	}
	else
	{
		this._holdOrientation = player.ship.orientation;
		//log (this.name, "holding "+this._holdOrientation)
		this.Cursor = system.addVisualEffect("targeting-cursor", player.ship.position);
		this.FCB = addFrameCallback(this._moveCursor.bind(this));
		this._active = true;
	}
}

this._isPossibleTarget = function(entity)
{
	return (entity.isShip && !entity.isCloaked && entity.scanClass != "CLASS_NO_DRAW") //Apparently setting target to wormhole by script is not allowed: || (entity.isWormhole && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") == "EQUIPMENT_OK"));
}

this._moveCursor = function(delta)
{
	player.ship.orientation = this._holdOrientation;
	this.Cursor.position = this.Cursor.position.add(player.ship.velocity.multiply(delta));
	
	var speed = delta * this._cursorSpeed;
	var absPitch = Math.abs(player.ship.pitch);
	var absRoll = Math.abs(player.ship.roll);
	var absYaw = Math.abs(player.ship.yaw);
	
	if (absPitch >= this._lastPitch)
	{
		if (player.ship.pitch > 0) this.Cursor.position = this.Cursor.position.add(player.ship.vectorForward.multiply(speed)); 
		else if (player.ship.pitch < 0) this.Cursor.position = this.Cursor.position.add(player.ship.vectorForward.multiply(-speed));
	}
	if (absRoll >= this._lastRoll)
	{
		if (player.ship.roll > 0) this.Cursor.position = this.Cursor.position.add(player.ship.vectorRight.multiply(-speed));
		else if (player.ship.roll < 0) this.Cursor.position = this.Cursor.position.add(player.ship.vectorRight.multiply(speed));
	}
	if (absYaw >= this._lastYaw)
	{
		if (player.ship.yaw > 0) this.Cursor.position = this.Cursor.position.add(player.ship.vectorUp.multiply(speed));
		else if (player.ship.yaw < 0) this.Cursor.position = this.Cursor.position.add(player.ship.vectorUp.multiply(-speed));
	}
	
	this._lastPitch = absPitch;
	this._lastYaw = absYaw;
	this._lastRoll = absRoll;
}